function initKotaiColPhase2()//Link shapefiles to brick datablocks.
{
	%file = findFirstFile("Add-Ons/Server_KotaiCol/shapes/*.dts");
	while(isFile(%file))
	{
		%filebase = getWord(fileBase(%file),0);//brick1x1Data.dts || brick1x1Data 1.dts & brick1x1Data 2.dts
		if((%fileindex = getWord(fileBase(%file),1))$="")
			%fileindex = 0;
		if(isObject(%data = nametoid(%filebase)))
		{
			%data.kotaiCol[%fileindex] = %file;
			%data.kotaiColCount+=1;
		}
		%file = findNextFile("Add-Ons/Server_KotaiCol/shapes/*.dts");
	}


	%file = findFirstFile("Add-Ons/Kotai_*/shapes/*.dts");
	while(isFile(%file))
	{
		%filebase = getWord(fileBase(%file),0);
		if((%fileindex = getWord(fileBase(%file),1))$="")
			%fileindex = 0;
		if(isObject(%data = nametoid(%filebase)))
		{
			%data.kotaiCol[%fileindex] = %file;
			%data.kotaiColCount+=1;
		}
		%file = findNextFile("Add-Ons/Kotai_*/shapes/*.dts");
	}

	%fo = new FileObject();
	%fo.openforRead("Add-Ons/Server_KotaiCol/shapes/samesame.txt");
	while(!%fo.isEOF())
	{
		%line = %fo.readline();
		if(isObject(%weak = getField(%line,0)))
		{
			if(isObject(%strong = getField(%line,1)))
			{
				for(%i=0;%i<%strong.kotaiColCount;%i++)
				{
					%weak.kotaiCol[%i] = %strong.kotaiCol[%i];
				}
				%weak.kotaiColCount = %strong.kotaiColCount;
			}
			else
			{
				warn("samesame.txt - Source object "@getField(%line,1)@" not present.");
			}
		}
		else
		{
			warn("samesame.txt - Target object "@getField(%line,0)@" not present.");
		}
	}
	%fo.close();
	%fo.delete();
}

deactivatepackage(KotaiColPackage);
package KotaiColPackage
{
	function onMissionLoaded()
	{
		Parent::onMissionLoaded();
		initKotaiColPhase2();//Link shapefiles to brick datablocks.
	}
	function fxDTSBrick::onAdd(%brick)
	{
		if(!%brick.isPlanted)
			return;
		if(isObject(%data = %brick.getDatablock()))
		{
			if(%data.kotaiColCount>0)
			{
				%brick.schedule(100,"addKotaiCol");//If too many objects are created at once, some bricks may not work right.  So put this on a schedule.
			}
		}
	}
	function fxDTSBrick::addKotaiCol(%brick)
	{
		if(isObject(%data = %brick.getDatablock()))
		{
			%brick.kotaiColCount = %data.kotaiColCount;
			if(%brick.kotaiColCount>0)
			{
				%count = clientGroup.getCount();
				for(%c=0;%c<%count;%c++)//Hide new objects from clients
				{
					%client[%c]=clientGroup.getObject(0);
					clientGroup.remove(%client[%c]);
				}
				for(%i=0;%i<%brick.kotaiColCount;%i++)
				{
					%brick.kotaiCol[%i] = new TSStatic()//Add new object
					{
						position = %brick.position;
						rotation = %brick.rotation;
						scale = "0.5 0.5 0.5";
						shapeName = %data.kotaiCol[%i];
						brick = %brick;
					};
					if(!%brick.isColliding()||!%brick.isRaycasting())
					{
						%brick.kotaiCol[%i].setTransform("0 0 -1000 1 0 0 0");
					}
					%brick.kotaiCol[%i].setScopeAlways();//This glitch will permanently hide this shape from new clients.
					GhostAlwaysSet.remove(%brick.kotaiCol[%i]);
				}
				for(%c=0;%c<%count;%c++)//Let clients see new objects from this point on.
				{
					clientGroup.add(%client[%c]);
				}
			}
		}
	}
	function fxDTSBrick::onDeath(%brick)
	{
		if(%brick.kotaiColCount>0)
		{
			for(%i=0;%i<%brick.kotaiColCount;%i++)
			{
				if(isObject(%brick.kotaiCol[%i]))
				{
					%brick.kotaiCol[%i].setTransform("0 0 -1000 1 0 0 0");
				}
			}
		}
		Parent::onDeath(%brick);
	}
	function fxDTSBrick::onFakeDeath(%brick)
	{
		if(%brick.kotaiColCount>0)
		{
			for(%i=0;%i<%brick.kotaiColCount;%i++)
			{
				if(isObject(%brick.kotaiCol[%i]))
				{
					%brick.kotaiCol[%i].setTransform("0 0 -1000 1 0 0 0");
				}
			}
		}
		Parent::onFakeDeath(%brick);
	}
	function fxDTSBrick::onClearFakeDeath(%brick)
	{
		if(%brick.kotaiColCount>0)
		{
			if(%brick.isColliding()&&%brick.isRaycasting())
			{
				for(%i=0;%i<%brick.kotaiColCount;%i++)
				{
					if(isObject(%brick.kotaiCol[%i]))
					{
						%brick.kotaiCol[%i].setTransform(%brick.getTransform());
					}
				}
			}
		}
		Parent::onClearFakeDeath(%brick);
	}
	function fxDTSBrick::onRemove(%brick)
	{
		if(%brick.kotaiColCount>0)
		{
			for(%i=0;%i<%brick.kotaiColCount;%i++)
			{
				if(isObject(%brick.kotaiCol[%i]))
				{
					%brick.kotaiCol[%i].schedule(1,"delete");
				}
			}
		}
		Parent::onRemove(%brick);
	}
	function fxDTSBrick::setColliding(%brick,%bool)
	{
		if(%brick.kotaiColCount>0)
		{
			if(%bool&&%brick.isRaycasting())
			{
				for(%i=0;%i<%brick.kotaiColCount;%i++)
				{
					if(isObject(%brick.kotaiCol[%i]))
					{
						%brick.kotaiCol[%i].setTransform(%brick.getTransform());
					}
				}
			}
			else
			{
				for(%i=0;%i<%brick.kotaiColCount;%i++)
				{
					if(isObject(%brick.kotaiCol[%i]))
					{
						%brick.kotaiCol[%i].setTransform("0 0 -1000 1 0 0 0");
					}
				}
			}
		}
		Parent::setColliding(%brick,%bool);
	}
	function fxDTSBrick::setRaycasting(%brick,%bool)
	{
		if(%brick.kotaiColCount>0)
		{
			if(%bool&&%brick.isColliding())
			{
				for(%i=0;%i<%brick.kotaiColCount;%i++)
				{
					if(isObject(%brick.kotaiCol[%i]))
					{
						%brick.kotaiCol[%i].setTransform(%brick.getTransform());
					}
				}
			}
			else
			{
				for(%i=0;%i<%brick.kotaiColCount;%i++)
				{
					if(isObject(%brick.kotaiCol[%i]))
					{
						%brick.kotaiCol[%i].setTransform("0 0 -1000 1 0 0 0");
					}
				}
			}
		}
		Parent::setRaycasting(%brick,%bool);
	}
};
activatepackage(KotaiColPackage);